import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
 
/** @invariant _field != 3 */

public class ExampleGUI extends JFrame
{
    ExampleGUI ()
    {
        super ("Jcontract example");
        Container pane = getContentPane ();
        pane.setLayout (new FlowLayout ());

        pane.add (new PreButton ());
        pane.add (new PostButton ());
        pane.add (new InvariantButton ());
        pane.add (new AssertButton ());
        pane.add (new ConcurrencyButton ());

        addWindowListener (new WindowAdapter () {
            public void windowClosing (WindowEvent e) {
                System.exit (0);
            }
        });

        pack ();
        setVisible (true);
    }

    class PreButton extends JButton implements ActionListener {
        PreButton () {
            super ("@pre violation");
            addActionListener (this);
        }
        public void actionPerformed (ActionEvent event) {
            setMonth (13);
        }
    }

    class PostButton extends JButton implements ActionListener {
        PostButton () {
            super ("@post violation");
            addActionListener (this);
        }
        public void actionPerformed (ActionEvent event) {
            getSum (2, 3);
        }
    }

    class InvariantButton extends JButton implements ActionListener {
        InvariantButton () {
            super ("@invariant violation");
            addActionListener (this);
        }
        public void actionPerformed (ActionEvent event) {
            _field = 3;
            invariantViolation ();
        }
    }

    class AssertButton extends JButton implements ActionListener {
        AssertButton () {
            super ("@assert violation");
            addActionListener (this);
        }
        public void actionPerformed (ActionEvent event) {
            assertViolation (-1);
        }
    }

    class ConcurrencyButton extends JButton implements ActionListener {
        ConcurrencyButton () {
            super ("@concurrency violation");
            addActionListener (this);
        }
        public void actionPerformed (ActionEvent event) {
            concurrencyViolation ();
        }
    }


    /** @pre month >= 1 && month <= 12 */

    void setMonth (int month) {
        _month = month;
    }
    private int _month;


    /** @post $result == a + b */

    int getSum (int a, int b) {
        return a - b;  // should be a + b
    }


    void invariantViolation () {
        _field = 0;
    }

    void assertViolation (int arg)
    {
        int tmp = arg * 2;
        /** @assert tmp > 0 */
    }

    void concurrencyViolation ()
    {
        new ConcurrencyTest ().start ();
        new ConcurrencyTest ().start ();
    }

    static class ConcurrencyTest extends Thread {
        public void run () {
            sequentialMethod (); 
        }
    }

    /** @concurrency sequential */

    static void sequentialMethod ()
    {
        try {
            Thread.sleep (3000);
        } catch (InterruptedException e) {
        }
    }

    int _field;


    //////////

    public static void main (String[] args)
    {
        new ExampleGUI ();
    }
}
